<?php

namespace Pepitelabs\PWS\ReturnsManagementService;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidationFault ReturnsManagementService
 * Meta information extracted from the WSDL
 * - documentation: This class is used to return information to a WCF client when validation fails on a service parameter.
 * - nillable: true
 * - type: tns:ValidationFault
 * @subpackage Structs
 */
class ValidationFault extends AbstractStructBase
{
    /**
     * The Details
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail
     */
    public $Details;
    /**
     * Constructor method for ValidationFault
     * @uses ValidationFault::setDetails()
     * @param \Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail $details
     */
    public function __construct(\Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail $details = null)
    {
        $this
            ->setDetails($details);
    }
    /**
     * Get Details value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail|null
     */
    public function getDetails()
    {
        return isset($this->Details) ? $this->Details : null;
    }
    /**
     * Set Details value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail $details
     * @return \Pepitelabs\PWS\ReturnsManagementService\ValidationFault
     */
    public function setDetails(\Pepitelabs\PWS\ReturnsManagementService\ArrayOfValidationDetail $details = null)
    {
        if (is_null($details) || (is_array($details) && empty($details))) {
            unset($this->Details);
        } else {
            $this->Details = $details;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Pepitelabs\PWS\ReturnsManagementService\ValidationFault
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
